testcov <- function(x, covmod, ...)
{
    n <- nrow(x)
    covmod <- covmod
    args <- list(...)
    arguments <- list(...)
    if (length(arguments)) {
        onames <- names(formals(covmod))
        pm <- pmatch(names(arguments), onames, nomatch = 0)
        if (any(pm == 0)) warning(paste("some of ... do not match"))
        names(arguments[pm > 0]) <- onames[pm]
        oargs <- formals(covmod)
        oargs[pm] <- arguments[pm > 0]
        formals(covmod) <- oargs
    }
    defn <- c("function(x){covmod <-",deparse(covmod),"covmod(x)}")
    krcov <- eval(parse(text=defn))
    d <- c(0, dist(x))
    eps <- 1e-3 * max(d)
    z <- .Call("RCall_cov", d, eps, body(krcov), new.env())
    cov <- matrix(0, n, n)
    cov[lower.tri(cov)] <- z[-1]
    cov <- cov + t(cov)
    diag(cov) <- z[1]
    cov
}
