#include <S.h>
#include <math.h>
#define max(a,b) ((a > b)? a:b)

static char *Scovmod;
static double eps;

static void cov(int n, double *d, int pred)
{
    int i;
    char *modes[] = {"double"}, *results[1];
    long lengths[1];
    void *arguments[1];

    for (i = 0; i < n; ++i) d[i] = max(sqrt(d[i]), pred*eps);
    *arguments = (void *)d; lengths[0] = n;
    call_R(Scovmod, 1L, arguments, modes, lengths, 
	   (char **)NULL, 1L, results);
    for (i = 0; i < n; ++i) d[i] = ((double *)(*results))[i];
}

void test_cov(double *ineps, void *Scode, 
              int *n, double *d, int *pred)
{
    eps = *ineps; Scovmod = Scode;
    cov(*n, d, *pred);
}
