#include <S.h>
#include <math.h>
#define max(a,b) ((a > b)? a:b)

static double eps;
static void *Scovmod;

void VR_cmset(float *ineps, void **Scode)
{
    eps = *ineps; Scovmod = *Scode;
}

static void cov(long n, double *d, long pred)
{
    int i;
    char *modes[] = {"double"};
    long lengths[1];
    void *arguments[1], *results[1];

    for (i = 0; i < n; ++i) d[i] = max(sqrt(d[i]), pred*eps);
    *arguments = (void *)d; lengths[0] = n;
    call_S(Scovmod, 1L, arguments, modes, lengths, 
	   (char **)NULL, 1L, results);
    for (i = 0; i < n; ++i) d[i] = ((double *)(*results))[i];
}

void test_cov(long *n, double *d, long *pred) 
{
    cov(*n, d, *pred);
}

