menuLDA <-
  function(formula, data, subset, na.omit.p = T,
    method = "moment", newdata = NULL, predict.save = NULL,
    predict.method = "plug-in", plot.p = F, plot.dimen = 99,
    CV = F, nu = 5)
{
  fun.call <- match.call()
  fun.call[[1]] <- as.name("lda.formula")
  if(na.omit.p) fun.call$na.action <- as.name("na.omit")
  else fun.call$na.action <- as.name("na.fail")
  fun.args <- is.element(arg.names(fun.call),
      c("formula", "data", "subset", "na.action",
        "method", "CV", "nu"))
  fun.call <- fun.call[c(T, fun.args)]
  ldaobj <- eval(fun.call)
  if(!CV) tabResults.lda(ldaobj)
  if(!CV)
    tabPredict.LDA(ldaobj,newdata,predict.save,predict.method)
  if(!CV && plot.p) tabPlot.LDA(ldaobj, plot.dimen=plot.dimen)
  invisible(ldaobj)
}

tabResults.LDA <- function(object)
{
  cat("\n\t*** Linear Discriminant Analysis ***\n")
  invisible(print.lda(object))
}

tabPredict.LDA <-
  function(object, newdata = NULL, predict.save = NULL,
           predict.method = "plug-in")
{
  if(!is.null(predict.save)) {
    if(is.null(newdata))
      predobj <- predict(object, method = predict.method)
    else
      predobj <- predict(object, newdata = newdata,
                         method = predict.method)
    if(exists(predict.save, where = 1)) {
      newsave.name <- unique.name(predict.save, where = 1)
      assign(newsave.name, predobj, where = 1)
      warning(paste("Predictions saved in", newsave.name))
    } else assign(predict.save, predobj, where = 1)
  }
  invisible(NULL)
}

tabPlot.LDA <- function(object, plot.dimen = 99)
{
  plot.lda(object, dimen = plot.dimen)
  invisible(NULL)
}
